﻿-- Author      : Kali
local HeraldSpeaks = ""

local frame = CreateFrame("Frame")

local msgType = {
["pvp"] = "BATTLEGROUND",
["arena"] = "PARTY",
["party"] = "PARTY",
["raid"] = "RAID",
}

local antispam = {}

function HeraldChatter()
	local inGroup = IsInGroup()
	local inInstance, instanceType = IsInInstance()
	local HeraldType = ""

	if HeraldSay==true then
		HeraldType = "SAY"
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		HeraldType = "INSTANCE_CHAT"
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		HeraldType = msgType[instanceType]
	end

	if (HeraldRW == true and (UnitIsGroupAssistant("player") or UnitIsGroupLeader("player")) and instanceType=="raid") then
		HeraldType = "RAID_WARNING"
	end
	SendChatMessage(HeraldSpeaks, HeraldType)
end

local function handler (msg)
	if msg == '' then
		HeraldHelp()
	elseif msg == 'on' then
		Herald = true
		frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		print("Your Herald is currently: "..getStatus(Herald))
	elseif msg == 'off' then
		Herald = false
		frame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		print("Your Herald is currently: "..getStatus(Herald))
	elseif msg == 'say' then
		HeraldSay = true
		print("Your Herald is announcing on "..CheckStatus().." .")
	elseif msg == 'rw' then
		HeraldRW = not HeraldRW
		print("Your Herald is announcing on raid warning when it can.")
	elseif msg == 'group' then
		HeraldSay = false
		print("Your Herald is announcing on "..CheckStatus().." .")
	elseif msg == 'status' then
		print("Your Herald is currently: "..getStatus(Herald))
		print("Your Herald is speaking through: "..CheckStatus())
	end
end

SlashCmdList["Herald"] = handler;
SLASH_Herald1 = "/Herald"

function HeraldHelp()
	print("Your Herald is currently: "..getStatus(Herald))
	print("To check the status: /herald status")
	print("To have your Herald speak: /herald on")
	print("To silence your Herald: /herald off")
	print("To announce in says: /herald say")
	print("To announce in group: /herald group")
	print("To announce on raid warnings: /herald rw")
end

function getStatus(cond)
	if cond==true then
		return "|cffff0000Speaking|r"	
	else
		return "|cffff0000Silent|r"
	end
end

function CheckStatus()
	if HeraldRW == true then
		return "|cffff0000Raid Warnings if Lead/Assist|r"
	elseif HeraldSay == false then
		return "|cffff0000Group|r"
	end
	return "|cffff0000Says|r"
end

local HeraldSpells = {
	[11419] = true, -- Portal: Darnassus
    [32266] = true, -- Portal: Exodar
    [11416] = true, -- Portal: Ironforge
    [11417] = true, -- Portal: Orgrimmar
    [32267] = true, -- Portal: Silvermoon
    [10059] = true, -- Portal: Stormwind 
    [49360] = true, -- Portal: Theramore
    [11420] = true, -- Portal: Thunder Bluff
    [11418] = true, -- Portal: Undercity
    [49361] = true, -- Portal: Stonard
    [120146] = true, -- Ancient Portal: Dalaran
    [53142] = true, -- Portal: Dalaran
    [88345] = true, -- Portal: Tol Barad
    [88346] = true, -- Portal: Tol Barad
    [132620] = true, -- Portal: Vale of Eternal Blossoms
    [132626] = true, -- Portal: Vale of Eternal Blossoms
    [33691] = true, -- Portal: Shattrath
    [35717] = true, -- Portal: Shattrath
	[87915] = true, -- Goblin BBQ
	[87643] = true, -- Broiled Dragon Feast
	[87644] = true, -- Seafood Magnifique Feast
	[92649] = true, -- Cauldron of Battle
	[92712] = true, -- Big Cauldron of Battle
--	[92827] = true, -- Ritual of Refreshment rank 3 aka mage table
--	[92824] = true, -- Ritual of Refreshment rank 2 aka mage table
	[698] = true, -- Ritual of Summoning
	[105193] = true, -- Great Pandaren Banquet
	[104958] = true, -- Pandaren Banquet
	[145166] = true, -- Noodle Cart
	[145169] = true, -- Deluxe Noodle Cart
	[145196] = true, -- Pandaren Treasure Noodle Cart
}

local HeraldBrew = {
	[126503] = true, -- Banquet of the Brew
	[126504] = true, -- Great Banquet of the Brew
}

local HeraldGrill = {
	[126492] = true, -- Banquet of the Grill
	[126494] = true, -- Great Banquet of the Grill
}

local HeraldOven = {
	[126501] = true, -- Banquet of the Oven
	[126502] = true, -- Great Banquet of the Oven
}

local HeraldPot = {
	[126497] = true, -- Banquet of the Pot
	[126498] = true, -- Great Banquet of the Pot
}

local HeraldSteam = {
	[126499] = true, -- Banquet of the Steamer
	[126500] = true, -- Great Banquet of the Steamer
}

local HeraldWok = {
	[126495] = true, -- Banquet of the Wok
	[126496] = true, -- Great Banquet of the Wok
	}
	
local HeraldCookies = {
	[29893] = true, -- Ritual of Souls aka Lock cookies
}

local HeraldMage = {
	[43987] = true, -- Ritual of Refreshment
}

local HeraldGResBank = {
	[83968] = true, -- Mass Resurrection
	[83958] = true, -- Mobile Banking
	[54710] = true, -- MOLL-E aka Mailbox
}

local HeraldRepair = {
	[54711] = true, -- Scrapbot
	[22700] = true, -- Field Repair Bot 74A
	[44389] = true, -- Field Repair Bot 110G
	[67826] = true, -- Jeeves
}

frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_LOGIN")

frame:SetScript("OnEvent", function(self, event, ...)
	if event == "ADDON_LOADED" then
		if Herald == nil then
			Herald = true
		end
		if HeraldSay == nil then
			HeraldSay = false
		end
		if HeraldRW == nil then
			HeraldRW = false
		end
		
		if Herald == true then
			frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		else
			frame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		end

	else
		local _, event, _, _, sourceName, _, _, _, _, _, _, spellID, spellName = ...		
		if (Herald == true and (UnitInParty(sourceName) or UnitInRaid(sourceName)) and (event=="SPELL_CAST_SUCCESS"  or event=="SPELL_CAST_START") and GetNumGroupMembers()>0 and (HeraldSpells[spellID] or HeraldGResBank[spellID] or HeraldMage[spellID] or HeraldCookies[spellID] or HeraldRepair[spellID] or HeraldBrew[spellID] or HeraldGrill[spellID] or HeraldOven[spellID] or HeraldPot[spellID] or HeraldSteam[spellID] or HeraldWok[spellID])) then
			if HeraldSpells[spellID] then
				HeraldSpeaks = "> "..sourceName.." set up a "..GetSpellLink(spellID).." <"
			end
			if HeraldMage[spellID] then
				HeraldSpeaks = "> "..sourceName.." has made us mana cakes! <"
			end
			if HeraldGResBank[spellID] then
				HeraldSpeaks = "> "..sourceName.." is casting "..GetSpellLink(spellID).." <"
			end
			if HeraldCookies[spellID] then
				HeraldSpeaks = "> "..sourceName.." has made us Lock Cookies! <"
			end
			if HeraldRepair[spellID] then
				HeraldSpeaks = "> "..sourceName.." has a "..GetSpellLink(spellID).." up! <"
			end
			if HeraldBrew[spellID] then
				HeraldSpeaks = "> "..sourceName.." has set a "..GetSpellLink(spellID).." (bonus Stam)! <"
			end
			if HeraldGrill[spellID] then
				HeraldSpeaks = "> "..sourceName.." has set a "..GetSpellLink(spellID).." (bonus Str)! <"
			end
			if HeraldOven[spellID] then
				HeraldSpeaks = "> "..sourceName.." has set a "..GetSpellLink(spellID).." (bonus Stam)! <"
			end
			if HeraldPot[spellID] then
				HeraldSpeaks = "> "..sourceName.." has set a "..GetSpellLink(spellID).." (bonus Int)! <"
			end
			if HeraldSteam[spellID] then
				HeraldSpeaks = "> "..sourceName.." has set a "..GetSpellLink(spellID).." (bonus Spirit)! <"
			end
			if HeraldWok[spellID] then
				HeraldSpeaks = "> "..sourceName.." has set a "..GetSpellLink(spellID).." (bonus Agi)! <"
			end
			
			if (antispam[HeraldSpeaks]==nil) then
				antispam[HeraldSpeaks] = time()
				HeraldChatter(HeraldSpeaks)
			elseif (time()-antispam[HeraldSpeaks])>12 then
				antispam[HeraldSpeaks] = time()
				HeraldChatter(HeraldSpeaks)
			end
		end
	end
end)